#pragma once
#include "AG_TPSymbolTable.h"
using namespace TinyPascal::Semantics;

// CASTView view

class CASTView : public CTreeView
{
	DECLARE_DYNCREATE(CASTView)

protected:
	CASTView();           // protected constructor used by dynamic creation
	virtual ~CASTView();

	//! Traverses the AST and displays every subtree
	void ShowSubTree(CAG_TPSymbolTable::TreeChildrenType& SubTree, HTREEITEM SubTreeRoot);

public:
#ifdef _DEBUG
	virtual void AssertValid() const;
#ifndef _WIN32_WCE
	virtual void Dump(CDumpContext& dc) const;
#endif
#endif
	//! Displays AST
	void ShowAST(CAG_TPSymbolTable::TreeChildrenType& AST);

protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual void OnInitialUpdate();

	CFont m_Font;
};


