// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "TinyPascal.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers




BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	if(!m_SplitterWnd.CreateStatic(this, 2, 2))
		return FALSE;

	if(!m_SplitterWnd.CreateView(0, 0, RUNTIME_CLASS(CTinyPascalView), CSize(700, 500), pContext) ||
	   !m_SplitterWnd.CreateView(1, 0, RUNTIME_CLASS(CCompileView), CSize(700, 100), pContext) ||
	   !m_SplitterWnd.CreateView(1, 1, RUNTIME_CLASS(CSymbolTableView), CSize(100, 100), pContext) ||
	   !m_SplitterWnd.CreateView(0, 1, RUNTIME_CLASS(CASTView), CSize(100, 500), pContext))
	{
		m_SplitterWnd.DestroyWindow();
		return FALSE;
	}

	return TRUE;
	// return CFrameWnd::OnCreateClient(lpcs, pContext);
}

CCompileView* CMainFrame::GetCompileView()
{
	return(static_cast<CCompileView*>(m_SplitterWnd.GetPane(1,0)));
}

CTinyPascalView* CMainFrame::GetProgramView()
{
	return(static_cast<CTinyPascalView*>(m_SplitterWnd.GetPane(0,0)));
}

CASTView* CMainFrame::GetASTView()
{
	return(static_cast<CASTView*>(m_SplitterWnd.GetPane(0,1)));
}

CSymbolTableView* CMainFrame::GetSymbolTableView()
{
	return(static_cast<CSymbolTableView*>(m_SplitterWnd.GetPane(1,1)));
}