// MainFrm.h : interface of the CMainFrame class
//


#pragma once
#include "afxext.h"
#include "CompileView.h"
#include "TinyPascalView.h"
#include "ASTView.h"
#include "SymbolTableView.h"

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

// Operations
public:

// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

	//! Returns pointer to compile view
	CCompileView* GetCompileView();

	//! Returns pointer to source code view
	CTinyPascalView* GetProgramView();

	//! Return reference to ASTView
	CASTView* GetASTView();

	//! Return Reference to Symbol table view
	CSymbolTableView* GetSymbolTableView();

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar   m_wndStatusBar;
	CToolBar     m_wndToolBar;
	CSplitterWnd m_SplitterWnd;

// Generated message map functions
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	DECLARE_MESSAGE_MAP()
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
};


