// SymbolTableView.cpp : implementation file
//

#include "stdafx.h"
#include "TinyPascal.h"
#include "SymbolTableView.h"


// CSymbolTableView

IMPLEMENT_DYNCREATE(CSymbolTableView, CListView)

CSymbolTableView::CSymbolTableView()
{
	m_Font.CreatePointFont(80, _T("Courier New"));
}

CSymbolTableView::~CSymbolTableView()
{
}

void CSymbolTableView::ShowSymbolTable(CAG_TPSymbolTable::SymbolTableType& SymbolTable)
{
	GetListCtrl().DeleteAllItems();
	CAG_TPSymbolTable::SymbolTableType::const_iterator iter = SymbolTable.begin();
	for(iter; iter!=SymbolTable.end(); ++iter)
	{
		CString strVariable(iter->first.c_str());
		CString strType("integer");
		if(iter->second == CAG_TPSymbolTable::real)
			strType = CString("real");
		else if(iter->second == CAG_TPSymbolTable::undefined)
			strType = CString("?");

		LVITEM Item;
		Item.mask			= LVIF_TEXT;
		Item.iItem			= GetListCtrl().GetItemCount();
		Item.iSubItem		= 0;
		Item.pszText		= strVariable.GetBuffer();

		LVITEM SubItem;
		SubItem.mask		= LVIF_TEXT;
		SubItem.iItem		= Item.iItem;
		SubItem.iSubItem	= 1;
		SubItem.pszText		= strType.GetBuffer();

		GetListCtrl().InsertItem(&Item);
		GetListCtrl().SetItem(&SubItem);
	}
}

BEGIN_MESSAGE_MAP(CSymbolTableView, CListView)
END_MESSAGE_MAP()


// CSymbolTableView diagnostics

#ifdef _DEBUG
void CSymbolTableView::AssertValid() const
{
	CListView::AssertValid();
}

#ifndef _WIN32_WCE
void CSymbolTableView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif
#endif //_DEBUG


// CSymbolTableView message handlers

void CSymbolTableView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();

	// Set font
	GetListCtrl().SetFont(&m_Font);

	// Set view to be details
	::SetWindowLong(GetListCtrl().m_hWnd, GWL_STYLE, GetWindowLong(GetListCtrl().m_hWnd, GWL_STYLE) | LVS_REPORT | LVS_SINGLESEL);
	GetListCtrl().SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

	// Add sigle column, where everything will happens
	CRect rect; GetListCtrl().GetClientRect(rect);
	GetListCtrl().DeleteColumn(1);
	GetListCtrl().DeleteColumn(0);
	GetListCtrl().InsertColumn(0, _T("Symbol"), 0, rect.Width()/2);
	GetListCtrl().InsertColumn(1, _T("Type"), 0, rect.Width()/2);
}
