// TinyPascalDoc.cpp : implementation of the CTinyPascalDoc class
//

#include "stdafx.h"
#include "TinyPascal.h"
#include "MainFrm.h"

#include "TinyPascalDoc.h"
#include "CntrItem.h"
#include "AG_TPCompiler.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTinyPascalDoc

IMPLEMENT_DYNCREATE(CTinyPascalDoc, CRichEditDoc)

BEGIN_MESSAGE_MAP(CTinyPascalDoc, CRichEditDoc)
	// Enable default OLE container implementation
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, &CRichEditDoc::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, &CRichEditDoc::OnEditLinks)
	ON_UPDATE_COMMAND_UI_RANGE(ID_OLE_VERB_FIRST, ID_OLE_VERB_LAST, &CRichEditDoc::OnUpdateObjectVerbMenu)
	ON_COMMAND(ID_BUILD_COMPILE, &CTinyPascalDoc::OnBuildCompile)
END_MESSAGE_MAP()


// CTinyPascalDoc construction/destruction

CTinyPascalDoc::CTinyPascalDoc()
{
}

CTinyPascalDoc::~CTinyPascalDoc()
{
}

BOOL CTinyPascalDoc::OnNewDocument()
{
	if (!CRichEditDoc::OnNewDocument())
		return FALSE;

	return TRUE;
}

CRichEditCntrItem* CTinyPascalDoc::CreateClientItem(REOBJECT* preo) const
{
	return new CTinyPascalCntrItem(preo, const_cast<CTinyPascalDoc*>(this));
}

// CTinyPascalDoc serialization

void CTinyPascalDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		CString strText;
		GetView()->GetRichEditCtrl().GetWindowText(strText);
		ar.WriteString(strText);
	}
	else
	{
		CString strLine;
		CString strText;
		while(ar.ReadString(strLine))
			strText += strLine + _T("\n");

		GetView()->GetRichEditCtrl().SetWindowText(strText);
	}

	// Calling the base class CRichEditDoc enables serialization
	// of the container document's COleClientItem objects.
	// TODO: set CRichEditDoc::m_bRTF = FALSE if you are serializing as text
	// CRichEditDoc::m_bRTF = FALSE;
	// CRichEditDoc::Serialize(ar);
}


// CTinyPascalDoc diagnostics

#ifdef _DEBUG
void CTinyPascalDoc::AssertValid() const
{
	CRichEditDoc::AssertValid();
}

void CTinyPascalDoc::Dump(CDumpContext& dc) const
{
	CRichEditDoc::Dump(dc);
}
#endif //_DEBUG


// CTinyPascalDoc commands

void CTinyPascalDoc::OnBuildCompile()
{
	CTinyPascalView* pProgramView = ((CMainFrame*)GetFirstFrame())->GetProgramView();
	CCompileView* pCompileView = ((CMainFrame*)GetFirstFrame())->GetCompileView();
	CSymbolTableView* pSymbolTableView = ((CMainFrame*)GetFirstFrame())->GetSymbolTableView();
	CASTView* pASTView = ((CMainFrame*)GetFirstFrame())->GetASTView();

	pCompileView->GetListCtrl().DeleteAllItems();

	CString strPath = GetPathName().Mid(0, GetPathName().ReverseFind('\\')+1);
	if(strPath.IsEmpty())
	{
		AfxMessageBox("Please save document before compilation!");
		return;
	}
	
	CString strText;
	pProgramView->GetRichEditCtrl().GetWindowText(strText);
	string program(strText.GetBuffer());
	TinyPascal::CAG_TPCompiler compiler;
	compiler.m_strWorkingDir = string(strPath.GetBuffer());
	if(compiler.Compile(program))
	{
		pCompileView->AddMessage("Build Success!");
	}
	else
	{
		// Display Errors
		list<string>::iterator iter1 = TinyPascal::CAG_TPMessageLog::m_ErrorLog.begin();
		for(iter1; iter1 != TinyPascal::CAG_TPMessageLog::m_ErrorLog.end(); ++iter1)
			pCompileView->AddMessage(iter1->c_str());

		pCompileView->AddMessage("Build Failure!");
	}

	// Display warnings
	list<string>::iterator iter2 = TinyPascal::CAG_TPMessageLog::m_WarningLog.begin();
	for(iter2; iter2 != TinyPascal::CAG_TPMessageLog::m_WarningLog.end(); ++iter2)
		pCompileView->AddMessage(iter2->c_str());

	// Display AST and SymbolTable
	pSymbolTableView->ShowSymbolTable(compiler.m_SymbolTable.GetSymbolTable());
	pASTView->ShowAST(compiler.m_AST);





	//CWaitCursor WaitCursor;
	//DWORD dwStartTime = ::GetTickCount();
	//DWORD dwEndTime = 0;

	//// Get pointer to both views
	//CTinyPascalView* pProgramView = ((CMainFrame*)GetFirstFrame())->GetProgramView();
	//CCompileView* pCompileView = ((CMainFrame*)GetFirstFrame())->GetCompileView();
	//CASTView* pASTView = ((CMainFrame*)GetFirstFrame())->GetASTView();
	//CSymbolTableView* pSymbolTableView = ((CMainFrame*)GetFirstFrame())->GetSymbolTableView();

	//// Delete all entries 
	//pSymbolTableView->GetListCtrl().DeleteAllItems();
	//pCompileView->GetListCtrl().DeleteAllItems();
	//pCompileView->GetListCtrl().InsertItem(pCompileView->GetListCtrl().GetItemCount(), _T("----- Build: ") + GetTitle() + _T(" -----"));
	//pCompileView->GetListCtrl().InsertItem(pCompileView->GetListCtrl().GetItemCount(), _T("Compiling process started ..."));

	//// Get current text and store it into vector
	//CString strText;
	//pProgramView->GetRichEditCtrl().GetWindowText(strText);
	//vector<TCHAR> program;
	//for(int i=0; i<strText.GetLength(); ++i)
	//	program.push_back(strText[i]);

	//// Create grammars
	//Grammar::TinyPascalGrammar grammar;
	//Grammar::TinyPascalSkipper skip;

	//// Get starting/ending iterator
	//position_iterator<vector<TCHAR>::const_iterator> begin(program.begin(), program.end());
	//position_iterator<vector<TCHAR>::const_iterator> end;
	//// vector<TCHAR>::const_iterator begin = program.begin();
	//// vector<TCHAR>::const_iterator end = program.end();

	//pCompileView->GetListCtrl().InsertItem(pCompileView->GetListCtrl().GetItemCount(), _T("Parsing and constructing AST ..."));

	//// Parse program
	//// tree_parse_info<vector<TCHAR>::const_iterator> info = ast_parse(begin, end, grammar, skip);
	//node_val_data_factory<CExpressionType> factory;
	//tree_parse_info<position_iterator<vector<TCHAR>::const_iterator>, node_val_data_factory<CExpressionType> > info = ast_parse(begin, end, grammar, skip, factory);

	//if(!info.full)
	//{
	//	// Display end of process info
	//	dwEndTime = ::GetTickCount();
	//	CString strTmp;
	//	file_position error_pos = info.stop.get_position();
	//	strTmp.Format(_T("    Syntax error in line %d"), error_pos.line);
	//	pCompileView->GetListCtrl().InsertItem(pCompileView->GetListCtrl().GetItemCount(), strTmp);
	//	
	//	CString strMessage; strMessage.Format(_T("===== Build: Failed! Syntax Error ===== (%d ms)."), dwEndTime-dwStartTime);
	//	pCompileView->GetListCtrl().InsertItem(pCompileView->GetListCtrl().GetItemCount(), strMessage);
	//}
	//else 
	//{
	//	/*
	//		Constructing symbol table from AST. Symbol table is constructed by traversing 
	//		secons and third subtree.
	//	*/
	//	pCompileView->GetListCtrl().InsertItem(pCompileView->GetListCtrl().GetItemCount(), _T("Constructing symbol table ..."));
	//	BOOL bRes = BuildSymbolTable(info.trees[0].children);
	//	pSymbolTableView->ShowSymbolTable(m_SymbolTable);

	//	// Display end of process info
	//	dwEndTime = ::GetTickCount();
	//	if(bRes)
	//	{
	//		// Determine type for each expression
	//		bRes = TRUE;
	//		DetermineType(info.trees[0].children, bRes);

	//		// Show result
	//		if(bRes)
	//		{
	//			CString strMessage; strMessage.Format(_T("===== Build: Success! ===== (%d ms)."), dwEndTime-dwStartTime);
	//			pCompileView->GetListCtrl().InsertItem(pCompileView->GetListCtrl().GetItemCount(), strMessage);
	//		}
	//		else
	//		{
	//			CString strMessage; strMessage.Format(_T("===== Build: Failed! Sematic Error ===== (%d ms)."), dwEndTime-dwStartTime);
	//			pCompileView->GetListCtrl().InsertItem(pCompileView->GetListCtrl().GetItemCount(), strMessage);
	//		}
	//	}
	//	else
	//	{
	//		CString strMessage; strMessage.Format(_T("===== Build: Failed! Sematic Error ===== (%d ms)."), dwEndTime-dwStartTime);
	//		pCompileView->GetListCtrl().InsertItem(pCompileView->GetListCtrl().GetItemCount(), strMessage);
	//	}
	//}

	//// Display tree
	//pASTView->GetTreeCtrl().DeleteAllItems();
	//pASTView->ShowAST(info.trees, NULL);
}