// TinyPascalView.cpp : implementation of the CTinyPascalView class
//

#include "stdafx.h"
#include "TinyPascal.h"

#include "TinyPascalDoc.h"
#include "CntrItem.h"
#include "TinyPascalView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTinyPascalView

IMPLEMENT_DYNCREATE(CTinyPascalView, CRichEditView)

BEGIN_MESSAGE_MAP(CTinyPascalView, CRichEditView)
	ON_WM_DESTROY()
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CRichEditView::OnFilePrintPreview)
	ON_WM_CHAR()
	ON_NOTIFY_REFLECT(EN_MSGFILTER, &CTinyPascalView::OnEnMsgfilter)
END_MESSAGE_MAP()

// CTinyPascalView construction/destruction

CTinyPascalView::CTinyPascalView()
{
	m_Font.CreatePointFont(80, _T("Courier New"));
}

CTinyPascalView::~CTinyPascalView()
{
}

BOOL CTinyPascalView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CRichEditView::PreCreateWindow(cs);
}

void CTinyPascalView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();

	// Set the printing margins (720 twips = 1/2 inch)
	SetMargins(CRect(720, 720, 720, 720));

	// Request message filtering
	GetRichEditCtrl().SetEventMask(GetRichEditCtrl().GetEventMask() | ENM_KEYEVENTS);

	// Set font
	SetFont(&m_Font);
}


// CTinyPascalView printing

BOOL CTinyPascalView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}


void CTinyPascalView::OnDestroy()
{
	// Deactivate the item on destruction; this is important
	// when a splitter view is being used
   COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
   if (pActiveItem != NULL && pActiveItem->GetActiveView() == this)
   {
      pActiveItem->Deactivate();
      ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
   }
   CRichEditView::OnDestroy();
}



// CTinyPascalView diagnostics

#ifdef _DEBUG
void CTinyPascalView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CTinyPascalView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

//CTinyPascalDoc* CTinyPascalView::GetDocument() const // non-debug version is inline
//{
//	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTinyPascalDoc)));
//	return (CTinyPascalDoc*)m_pDocument;
//}
#endif //_DEBUG


// CTinyPascalView message handlers

void CTinyPascalView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if(nChar == '\t')
		nChar = ' ';
	
	CRichEditView::OnChar(nChar, nRepCnt, nFlags);
}

void CTinyPascalView::OnEnMsgfilter(NMHDR *pNMHDR, LRESULT *pResult)
{
	MSGFILTER *pMsgFilter = reinterpret_cast<MSGFILTER *>(pNMHDR);
	// TODO:  The control will not send this notification unless you override the
	// CRichEditView::OnInitDialog() function to send the EM_SETEVENTMASK message
	// to the control with either the ENM_KEYEVENTS or ENM_MOUSEEVENTS flag 
	// ORed into the lParam mask.

	// TODO:  Add your control notification handler code here
	if((pMsgFilter->msg == WM_KEYDOWN) || (pMsgFilter->msg == WM_KEYUP) || (pMsgFilter->msg == WM_CHAR))
	{
		if(pMsgFilter->wParam == 9)
		{
			pMsgFilter->wParam = 32;
			if(pMsgFilter->msg == WM_KEYDOWN)
			{
				::PostMessage(pMsgFilter->nmhdr.hwndFrom, WM_CHAR, 32, 0);
				::PostMessage(pMsgFilter->nmhdr.hwndFrom, WM_CHAR, 32, 0);
				::PostMessage(pMsgFilter->nmhdr.hwndFrom, WM_CHAR, 32, 0);
			}
		}
	}

	*pResult = 0;
}
